%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %% Implementacin del Diferential Evolution %%
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [xopt,fxopt,fevalcount, FOPT, RunStats]= DE_PBIL_MT(MaxIt,Max_FES,pop_size,dim,Xmin,Xmax,GM,nexp,fhd, sistema,handles, varargin)
 
 clc;
% RandStream.setGlobalStrea ...
% (RandStream('mt19937ar','seed',sum(100*clock))); % Different random generator seeds per execution
 rand('state',sum(100*clock));
 Acc = 1e-3; % Precision Deseada

 RunStats = [ ]; % Matriz de estadisticas promediadas
 
% INICIALIZACIN DE LOS PARMETROS  DEL "PBILc"
 mejores_individuos=round(pop_size/2); % Porcentaje del total de mejores individuos
 Tasa_de_aprendi=0.08;              % Tasa de aprendizaje
% INICIALIZACIN DE LOS PARMETROS DEL ALGORITMO "DE"
F1=1;    % Factor de escala F
Cr1=0.2; % Tasa de cruce Cr
 xopt=zeros(dim, nexp);
 FOPT=zeros(MaxIt, nexp);
 %===================================
 % Lazo del nmero de experimentos
 %===================================
 for T = 1:nexp
 % INICIALIZAR PARAMETROS
     success = 0; % Bandera de exito
     iter = 1; % Contador de iteraciones
     fevalcount = 0; % Contador del # del Evaluaciones de la Funcion Objetivo
     STOP = 0; % Bandera de parada del experimento
     opcion=3; % Creacion de soluciones iniciales tradicional 1 por defecto
 V=zeros(dim,pop_size);     
Dominio_Maximo=Xmax(1,1)*ones(dim,1);
Dominio_Minimo=Xmin(:,1);
Rango=Dominio_Maximo-Dominio_Minimo;
ProbVec =(Dominio_Minimo+2* Rango.* rand(dim, 1));%Vector de probabilidad (media)
ProbVec1 =2*ones(dim,1);      % Vector de probabilidades  (varianza)     
     
     
costo_lineas_U(1:pop_size)=10E9;
penalizacion_U(1:pop_size)=10E9;
f_U(1:pop_size)=10E12;
 % pop, VELOCIDADES & INICIALIZACION DE LA MEJOR POSICION
 
    %Llamar a funcion psocreacioninicial para obtener soluciones iniciales
    pop=psocreacioninicial(Xmin, Xmax, dim, pop_size, sistema, fhd, opcion);
    

% Esta parte de la rutina calcula los costos con penalizacion de la manera
% tradicional y puede ser usada por defecto 
     
   parfor i=1:pop_size
      [costo_lineas(i), penalizacion(i)]=feval(fhd, pop(:,i), sistema);
      f_X(i)=costo_lineas(i)+penalizacion(i);
      fevalcount=fevalcount+1;  
   end

  % ORDENAR LOS INDIVIDUOS EN FUNCION DEL COSTO 
      fbestpos=f_X;                        % Inicializacion de los costos de la mejor posicion       
      [fxopt,posicion_mejor] = sort(fbestpos, 'ascend');  % Ordenar los individuos en funcion del costo
      xopt(:,T) = pop(:,posicion_mejor(1));%Individuo que proporciona la mejor solucion
      FOPT(iter,T)=fxopt(1);   % Valor (costo) del individuo con la mejor solucion         
      poblacion2=pop(:,posicion_mejor);  
     
     %======================
     % LAZO DE EVOLUCION DEL ENJAMBRE
     %======================
     while (STOP == 0)
         
         % ACTUALIZAR CONTADOR DE ITERACIONES
         iter = iter+1;

  % ACTUALIZACION DEL VECTOR DE PROBABILIDAD TANTO CON LOS MEJORES COMO CON LOS PEORES INDIVIDUOS               
     ProbVec(:,1) = (1-Tasa_de_aprendi)*ProbVec(:,1) + Tasa_de_aprendi * (poblacion2(:,1)+poblacion2(:,2) - poblacion2(:,pop_size));
     ProbVec1(:,1) = (1-Tasa_de_aprendi)*ProbVec1(:,1) + Tasa_de_aprendi *std(poblacion2(:,1:mejores_individuos),1,2);       
     
% VERIFICAR QUE EL VECTOR DE PROBABILIDAD NO CONVERJA    
            for i=1:dim
                ProbVec(i,1) = max(min(ProbVec(i,1),Dominio_Maximo(i,1)),Dominio_Minimo(i,1)); 
            end 
            
            
% GENERAR UN NUEVO DESCENDIENTE
  for i=1:pop_size
          Aleatorio_nume=rand(); %Numero aleat. para determinar si se utiliza DE o PBILc
          if  Aleatorio_nume<0.9 % Utilizar mutacion del "DE"
            indices=randi(pop_size, 4,1);
            for k=1:4
                for l=1:4
                    if k~=l
                      if indices(k)==indices(l)
                          indices(k)=randi(pop_size);
                      end
                      if indices(k)==i
                          indices(k)=randi(pop_size);
                      end
                    end
                end
            end
             R1=indices(1); % Obtener numero aleatorios
             R2=indices(2);
             R3=indices(3);
             R4=indices(4);
             %CREACION DEL VECTOR DONADOR
   mutacion_aleatoria=rand(); % Generar un numero aleatorio
      if mutacion_aleatoria<0.3 % Utilizar mutacion trigonometrica
           
      pert_total=f_X(R1)+f_X(R2)+f_X(R3) ;
        pert1=f_X(R1)/pert_total;
        pert2=f_X(R2)/pert_total;
        pert3=f_X(R3)/pert_total;
          V(:,i) = (pop(:,R1)+pop(:,R2)+pop(:,R3))/3+(pert2-pert1)*(pop(:,R1)-pop(:,R2))+...
              (pert3-pert2)*(pop(:,R2)-pop(:,R3))+(pert1-pert3)*(pop(:,R3)-pop(:,R1));  

      else   %Utilizar mutacion Diferencial 
             V(:,i) = pop(:,posicion_mejor(1))+F1*(pop(:,R1)+pop(:,R2)-pop(:,R3)-pop(:,R4));
       end         
%VERIFIAR QUE EL VECTOR DONADOR NO SUPERE LOS LIMITES DE BUSQUEDA                  
        V(:,i)=round(V(:,i));
          for j=1:dim
                   if V(j,i)>Xmax(j,i)
                     V(j,i) = Xmax(j,i);
                   end
                   if V(j,i)<Xmin(j,i)
                     V(j,i) = Xmin(j,i);
                   end
             
          end 
           
%UTILIZZAR CRUZAMIETNO BINOMIAL
       U(:,i)=round(pop(:,i));
       jrand=randi(dim);
       for j=1:dim
          if (rand<=Cr1)||(j==jrand)
              U(j,i)=V(j,i);
          end
       end
 
             
          else   % GENERAR LA NUEVA POBLACION UTILIZANDO PBILc
    U(:,i)=round(normrnd(repmat(ProbVec,1),repmat(ProbVec1,1)));
          end
%VERIFIAR QUE EL VECTOR DONADOR NO SUPERE LOS LIMITES DE BUSQUEDA 
                for j=1:dim
                   if U(j,i)>Xmax(j,i)
                     U(j,i) = Xmax(j,i);
                   end
                   if U(j,i)<Xmin(j,i)
                     U(j,i) = Xmin(j,i);
                   end
                 end             
end

          % Selection
          
          for i=1:pop_size
              [costo_temp(i)]=costo_adicion_MT(U(:,i), sistema);
              if costo_temp(i)<f_X(i)
                  ind_eval(i)=i;

              else
                  ind_eval(i)=0;
              end
              f_U(i)=f_X(i);        
          end
          
% CALCULO DE LOS COSTOS DE CADA INDIVIDUO
          parfor i=1:pop_size      
            if i==ind_eval(i) 
               [costo_lineas_U(i), penalizacion_U(i)]=feval(fhd, U(:,i), sistema);
               f_U(i)=costo_lineas_U(i)+penalizacion_U(i);
               fevalcount=fevalcount+1; 
              end
          end
          
          
          
      for i=1:pop_size    
        if f_U(i) <f_X(i)
            f_X(i)=f_U(i);
            pop(:,i)=U(:,i);
        end
      end
      
% ACTUALIZAR DE LOS MEJORES INDIVIDUOS 
   
      fbestpos=f_X;                        % Inicializacion de los costos de la mejor posicion       
      [fxopt,posicion_mejor] = sort(fbestpos, 'ascend');  % Ordenar los individuos en funcion del costo
      xopt(:,T) = pop(:,posicion_mejor(1));%Individuo que proporciona la mejor solucion
      FOPT(iter,T)=fxopt(1);   % Valor (costo) del individuo con la mejor solucion         
      poblacion2=pop(:,posicion_mejor); 
            
         
         % ALMACENAR Y GRAFICAR LOS VALORES OPTIMOS PARA CADA ITERACION
         
         figure(1);
         plot(FOPT(:, T)');
         xlabel('Iter');
         ylabel('Fitness (x 1000 US$)');
         hold on;                
         
         % CHECK STOP CRITERION
         
        if ((fevalcount >= Max_FES)||(fxopt(1) <= GM+Acc))
         STOP = 1;
             if (fxopt <= GM+Acc)
             success = 1;
             end
        end
         
         
         if ((iter >= MaxIt)||(fxopt(1) <= GM+Acc))
         STOP = 1;
             if (fxopt(1) <= GM+Acc)
             success = 1;
             end
         end
        
 end % FINALIZAR EVOLUCION DEL ENJAMBRE

 %% ACTUALIZAR VECTOR DE ESTADISTICAS
     RunStats(T,:) = [success iter fevalcount];

     % IMPRIMIR LA SOLUCION DETECTADA EN PANTALLA
     fprintf('EXPERIMENTO #%3d :: EXITO 1d :: SOLUCION X*=(', T, success);
%      for i=1:dim
%         fprintf(' %15.5e', xopt(i));
%      end
     fprintf(')  :: F(X*)=12.5e :: ITER=%5d\n', fxopt(1), iter);
 end % FINALIZAR LAZO DEL NUMERO DE EXPERIMENTOS

%  %===========================
%  % IMPRIMIR ESTADISTICAS PROMEDIO
%  %===========================
 fprintf('\nESTADISTICAS PROMEDIO:\n');
 SucRunStats = RunStats(RunStats(:,1)==1,:);
 fprintf('EXITOS = %3d/%3d\n', sum(RunStats(:,1)),nexp);
 fprintf('ITERACIONES PROMEDIO = %8.2f\n', mean(SucRunStats(:,2)));
 fprintf('ITERACIONES DESVIACION St= %8.2f\n', std(SucRunStats(:,2)));
 fprintf('EVALUACIONES PROMEDIO DE FUNCION OBJETIVO . = %8.2f\n', mean(SucRunStats(:,3)));
 fprintf('DESVIACION St DE EVALUACION DE FUNCION OBJETIVO = %8.2f\n', std(SucRunStats(:,3)));
 fprintf('VALOR OPTIMO= %8.2f\n', fxopt(1));
 fprintf('EVALUACIONES DE LA FUNCION OBJETIVO DEL ULTIMO EXPERIMENTO= %8.2f\n', fevalcount);
 toc


xopt=round(xopt)
FOPT

function [costo_total]=costo_adicion_MT(x_posicion, sistema)
mpc=loadcase(sistema);
mpc.costo_lineas
 LineasIniciales=mpc.costo_lineas(:,1); 
Costos=mpc.costo_lineas(:,2);

numero_ramas=numel(LineasIniciales);
LT_nuevas=x_posicion(1:numero_ramas,:)-LineasIniciales; % recoje los costos y la 
  
  %% EVALUACION DE LA x_posicion %%
costo_total=sum(Costos.*LT_nuevas);

end
end






%**************************************************************************

