% Any publication resulting from the use of this m-file shall acknowledge
% it by citing the following paper:

%S. P. Torres and C. A. Castro, Expansion planning for smart transmission
%grids using ac model and shunt compensation, IET Generation,
%Transmission & Distribution, vol. 8, no. 5, pp. 966-975, 2014.


%% CREATION OF INITIAL POPULATION OF MODIFIED GARVER SYSTEM %%
function swarm=psocreacioninicial(Xmin, Xmax, dim, SS, sistema, fhd, opcion)

% Initial population consists of a number of individuals, where each
% indiviudal is represented by a vector, and element of the vector
% represents the number of existing transmission lines in each right-of-way
% rand('twister',5489);
% Store the new transmission lines %
if opcion==1 
  swarm=round(Xmin+(Xmax-Xmin).*(rand(dim,SS)));  
   for i=1:SS 
       
    indices=randi(dim, round(0.65*dim),1);
    swarm(indices,i)=Xmin(indices,i);
   end
   
   
 end
if opcion==2 
  swarm=round(Xmin+(Xmax-Xmin).*(rand(dim,SS)));  
   for i=1:SS 
       
     alpha=(0.6+0.25*rand);  
    indices=randi(dim, round(alpha*dim),1);
    swarm(indices,i)=Xmin(indices,i);
   end
   
   
 end
if opcion==3 
  swarm=round(Xmin+(Xmax-Xmin).*(rand(dim,SS)));  
end

if opcion==4
    swarm=round(Xmin+(Xmax-Xmin).*(rand(dim,SS)));  
   for i=1:SS 
       
     alpha=(0.6+0.2*rand);  
    indices=randi(dim, round(alpha*dim),1);
    swarm(indices,i)=Xmin(indices,i);
   end
   
    for i=1:SS/2 
       for j=1:dim
           if swarm(j,i)>Xmin(j,i)
             swarm(j,i+SS/2)=Xmax(j,i+SS/2)-swarm(j,i);
           end
           if swarm(j,i)<Xmin(j,i)
               swarm(j,i+SS/2)=Xmin(j,i);
           end
       end
    end



    for i=1:SS
        for k=i:SS
            if i~=k
                if swarm(:,i)==swarm(:,k)
                    swarm(:,i)=round(Xmin(:,i)+(Xmax(:,i)-Xmin(:,i)).*rand); 
                end
            end
        end
    end
end    

if opcion==5
   
    poblacion=TEP_AHC(Xmin, Xmax, dim, SS, sistema, fhd);
   

    for j=1:dim
        for i=1:SS
        Xmin(j,i)=poblacion(j);
        end
    end
        
   swarm=round(Xmin+(Xmax-Xmin).*(rand(dim,SS)));  
   
%    for i=1:SS 
%        
%      alpha=(0.8+0.2*rand);  
%     indices=randi(dim, round(alpha*dim),1);
%     swarm(indices,i)=Xmin(indices,i);
%    end
  
   
end

if opcion==6
    load ('PoblacionBrasil87.mat', 'PoblaEnt');
    PoblaEnt
    swarm=PoblaEnt';
    
end

if opcion==7 %This options seems to give the best results for GARVER system
    swarm=zeros(dim, SS);
     poblacion=TEP_AHC(Xmin, Xmax, dim, SS, sistema, fhd);

    Lnuevas=poblacion-Xmin(:,1);
    for i=1:SS
        for j=1:dim
            if Lnuevas(j)>0
                swarm(j,i)=round(Xmin(j,i)+(Xmax(j,i)-Xmin(j,i))*rand);
            else
                swarm(j,i)=Xmin(j,i);
            end
        end
    end

end

 if opcion==8 
    swarm=zeros(dim, SS);
     poblacion=TEP_AHC(Xmin, Xmax, dim, SS, sistema, fhd);
    
    Lnuevas=poblacion-Xmin(:,1);
    for i=1:SS/2
        for j=1:dim
            if Lnuevas(j)>0
                swarm(j,i)=round(Xmin(j,i)+(Xmax(j,i)-Xmin(j,i))*rand);
            else
                swarm(j,i)=Xmin(j,i);
            end
        end
    end
    
        for i=(SS/2+1):SS
        for j=1:dim
            if Lnuevas(j)==0
                swarm(j,i)=round(Xmin(j,i)+(Xmax(j,i)-Xmin(j,i))*rand);
            else
                swarm(j,i)=Lnuevas(j);
            end
        end
    end

end   
    